SystemOrganization addCategory: #'CS598rej-HW3'!
SystemOrganization addCategory: #'CS598rej-HW3-Test'!

TestCase subclass: #HW3ExercisesTest
	instanceVariableNames: 'exercise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW3-Test'!

!HW3ExercisesTest commentStamp: 'm3r 6/7/2008 09:10' prior: 0!
I am the SUnit test class for HW3.  Don't make any changes to me, just make my test cases green!! :-)!

!HW3ExercisesTest methodsFor: 'private' stamp: 'm3r 6/14/2008 01:15'!
readCodeFrom: readStream to: writeStream	
	| char |
	[readStream atEnd] whileFalse:
		[char := readStream next.
		char = $' ifTrue: [^ #readStringFrom:to:].
		char = $" ifTrue: [^ #readComment:to:].
		writeStream nextPut: char].
	^ nil
! !

!HW3ExercisesTest methodsFor: 'private' stamp: 'm3r 6/14/2008 01:07'!
readComment: readStream to: writeStream	
	| char |
	[readStream atEnd] whileFalse:
		[char := readStream next.
		char = $" ifTrue: [^ #readCodeFrom:to:]].
	self error: 'Malformed source code: Expecting end of comment " char!!'.
! !

!HW3ExercisesTest methodsFor: 'private' stamp: 'm3r 6/14/2008 01:16'!
readStringFrom: readStream to: writeStream	
	| char |
	writeStream nextPut: $'.
	[readStream atEnd] whileFalse:
		[char := readStream next.
		writeStream nextPut: char.
		char = $' ifTrue: 
			[(readStream peekFor: $') ifFalse: [^ #readCodeFrom:to:]]].
	self error: 'Malformed source code: Expecting end of string '' char!!'.
! !

!HW3ExercisesTest methodsFor: 'private' stamp: 'm3r 6/14/2008 01:20'!
removeCommentsFrom: sourceString
	| readStream nextAction |
	readStream := sourceString readStream.
	nextAction := #readCodeFrom:to:.
	^ String streamContents:
		[: writeStream |
		[nextAction isNil] whileFalse:
			[nextAction := self 
				perform: nextAction with: readStream with: writeStream]]
! !

!HW3ExercisesTest methodsFor: 'private' stamp: 'm3r 6/7/2008 11:31'!
reverseArrayTesting: aSelector
	| array reversed |
	array := 'Maurice Rabb' asArray.
	reversed := exercise perform: aSelector with: array.
	self assert: reversed = 'bbaR eciruaM' asArray.
	array := #(1).
	reversed := exercise perform: aSelector with: array.
	self assert: reversed = array.
	array := #().
	reversed := exercise perform: aSelector with: array.
	self assert: reversed = array.
! !

!HW3ExercisesTest methodsFor: 'running' stamp: 'm3r 6/7/2008 09:06'!
setUp
	exercise := HW3Exercises new.
! !

!HW3ExercisesTest methodsFor: 'testing' stamp: 'm3r 6/7/2008 10:54'!
testCalculateOddSumFromTo
	| sum |
	sum := exercise calculateOddSumFrom: 1 to: 9.
	self assert: sum = 25.
	sum := exercise calculateOddSumFrom: 12 to: 16.
	self assert: sum = 28.
	sum := exercise calculateOddSumFrom: 1 to: 101.
	self assert: sum = 2601.
! !

!HW3ExercisesTest methodsFor: 'testing' stamp: 'm3r 6/8/2008 20:49'!
testCalculateValuesForOddsUpTo
	| result answer | 
	result := exercise calculateValuesForOddsUpTo: 11.
	answer := #(2 80 145152 1779148800 79041650688000).
	self assert: result asArray = answer.
	result := exercise calculateValuesForOddsUpTo: 10.
	self assert: result asArray = answer.
	result := exercise calculateValuesForOddsUpTo: 9.
	self assert: result asArray = answer allButLast.
	result := exercise calculateValuesForOddsUpTo: 0.
	self assert: result isEmpty.
	result := exercise calculateValuesForOddsUpTo: -1.
	self assert: result isEmpty.
! !

!HW3ExercisesTest methodsFor: 'testing' stamp: 'm3r 6/7/2008 09:09'!
testIncrementingBlock
	| block |
	block := exercise incrementingBlock.
	self assert: block value = 1.
	self assert: block value = 2.
	self assert: block value = 3.
! !

!HW3ExercisesTest methodsFor: 'testing' stamp: 'm3r 6/7/2008 10:03'!
testMaxWithinArray
	| max |
	max := exercise maxWithinArray: #(2).
	self assert: max = 2.
	max := exercise maxWithinArray: #(4 7 33 1 5 3).
	self assert: max = 33.
	max := exercise maxWithinArray: #(-4 -7 -33 -1 -5 -3).
	self assert: max = -1.
	max := exercise maxWithinArray: #().
	self assert: max isNil.
! !

!HW3ExercisesTest methodsFor: 'testing' stamp: 'm3r 6/14/2008 01:58'!
testOrderedSquaresOf
	| result answer sourceCode | 
	result := exercise orderedSquaresOf: (1 to: 10).
	answer := #(1 4 9 16 25 36 49 64 81 100).
	self assert: answer = result asArray.
	result := exercise orderedSquaresOf: #().
	self assert: result isEmpty.
	sourceCode := HW3Exercises sourceCodeAt: #orderedSquaresOf:.
	sourceCode := self removeCommentsFrom: sourceCode.
	self should: [sourceCode includesSubString: 'whileTrue:'].
! !

!HW3ExercisesTest methodsFor: 'private' stamp: 'm3r 6/14/2008 01:23'!
testReadCodeFrom
	self should: 
		[(self removeCommentsFrom: 'code "comment with a ''string'' inside" more code') 
			= 'code  more code'].
	self should: 
		[(self removeCommentsFrom: 'code ''string with "coment chars" inside'' more code "comment"') 
			= 'code ''string with "coment chars" inside'' more code '].
! !

!HW3ExercisesTest methodsFor: 'testing' stamp: 'm3r 6/14/2008 01:58'!
testRepetition
	| sum sourceCode |
	sum := exercise repetition: 100.
	self assert: sum = 5050.
	sourceCode := HW3Exercises sourceCodeAt: #repetition:.
	sourceCode := self removeCommentsFrom: sourceCode.
	self should: [sourceCode includesSubString: 'timesRepeat:'].
! !

!HW3ExercisesTest methodsFor: 'testing' stamp: 'm3r 6/14/2008 00:31'!
testReverseArrayTheEasyWay
	self reverseArrayTesting: #reverseArrayTheEasyWay:.
	"The following test ensures that the method contains only one statement."
	self shouldnt: 
		[(HW3Exercises compiledMethodAt: #reverseArrayTheEasyWay:) 
			decompileString includes: $.].
! !

!HW3ExercisesTest methodsFor: 'testing' stamp: 'm3r 6/14/2008 00:32'!
testReverseArrayTheHardWay
	self reverseArrayTesting: #reverseArrayTheHardWay:.
	"The following test ensures that the method contains more than one statement."
	self should: 
		[(HW3Exercises compiledMethodAt: #reverseArrayTheHardWay:) 
			decompileString includes: $.].
! !

!HW3ExercisesTest methodsFor: 'testing' stamp: 'm3r 6/7/2008 12:09'!
testSumUsingWhileFalse
	| sum sourceCode |
	sum := exercise sumUsingWhileFalse.
	self assert: sum = 140.
	sourceCode := (HW3Exercises compiledMethodAt: #sumUsingWhileFalse) decompileString.
	self should: [sourceCode includesSubString: 'whileFalse'].
	self should: [(sourceCode select: [:char | char = $.]) size = 5].
! !

!HW3ExercisesTest methodsFor: 'testing' stamp: 'm3r 6/7/2008 12:12'!
testSumUsingWhileTrue
	| sum sourceCode |
	sum := exercise sumUsingWhileTrue.
	self assert: sum = 140.
	sourceCode := (HW3Exercises compiledMethodAt: #sumUsingWhileTrue) decompileString.
	self should: [sourceCode includesSubString: 'whileTrue'].
	self should: [(sourceCode select: [:char | char = $.]) size = 5].
! !

!HW3ExercisesTest methodsFor: 'testing' stamp: 'm3r 6/7/2008 10:25'!
testValueOfEmptyBlock
	| sourceString |
	self assert: exercise valueOfEmptyBlock isNil.
	sourceString := (HW3Exercises compiledMethodAt: #valueOfEmptyBlock) decompileString.
	self should: [(sourceString reject: #isSeparator) includesSubString: '^[]'].
! !

Object subclass: #HW3Exercises
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW3'!

!HW3Exercises commentStamp: 'm3r 6/7/2008 15:29' prior: 0!
To complete the HW3 assignment, complete all of the methods in the 'exercises' protocol, and make all of the test in HW3ExercisesTest run. :-)
!

!HW3Exercises methodsFor: 'exercises' stamp: 'MichaelOSullivan 6/8/2012 14:07'!
calculateOddSumFrom: startInteger to: endInteger
	"This method should answer the sum of the odd integers from the range.
	Hint: look in the 'testing' protocol of the Number class."
	
	| odds |
	odds := (startInteger to: endInteger) select:  [:each | each odd].
	^ odds inject: 0 into: [:sum :i | sum + i]! !

!HW3Exercises methodsFor: 'exercises' stamp: 'MichaelOSullivan 6/8/2012 14:20'!
calculateValuesForOddsUpTo: limit
	"This method should answer an ordered collection of integers.
	The returned values should be for all odd integers LESS than the 'limit',
	where the calculated value is the factorial of twice the integer, 
	divided by the square of the integer.
	Use the add: method to add each value to the OrderedCollection.
	Hint: Look in the 'testing' protocol of the Number class.
	Advanced: If you prefer, try implementing it using the select:thenCollect: method instead.
	Expert: See if you can avoid needing to use the add: at all!! :-)'"
	
	| odds temp result |
	temp := limit - 1.
	odds := (1 to: temp) select: [:each | each odd].
	result := odds collect: [:each | ((each * 2) factorial)/each squared].
	^result asOrderedCollection
	! !

!HW3Exercises methodsFor: 'exercises' stamp: 'MichaelOSullivan 6/10/2012 14:42'!
incrementingBlock
	"This method should answer a block which increments a temporary variable index by one."

	| temp |
	temp isNil ifTrue: [temp := 0 ].
	^[ temp := temp + 1]
! !

!HW3Exercises methodsFor: 'exercises' stamp: 'MichaelOSullivan 6/8/2012 14:13'!
maxWithinArray: anArray
	"This method should answer the maximum value in an array of numbers,"
	
	anArray size = 0 ifTrue: [^nil].
	^ anArray asSortedCollection last
! !

!HW3Exercises methodsFor: 'exercises' stamp: 'MichaelOSullivan 6/8/2012 11:31'!
orderedSquaresOf: numbers
	"This method should answer an OrderedCollection with the squares of the numbers 
	in ascending order.
	Use the add: method to add each square to the answered OrderedCollection.
	Use whileTrue: for your control structure."
	
	| index coll |
	coll := OrderedCollection new.
	index := 1.
	[index <= numbers size] whileTrue: 
	[
		coll add: ((numbers at: index) squared).
		index := index + 1.
	].
	^ coll asSortedCollection
! !

!HW3Exercises methodsFor: 'exercises' stamp: 'MichaelOSullivan 6/8/2012 11:38'!
repetition: positiveCount
	"This method should answer a the sum of 1 to positiveCount.
	Use timesRepeat: for your control structure."
	
	| sum index |
	sum := 0.
	index := 1.
	positiveCount timesRepeat:
	[
		sum := sum + index.
		index := index +1
	].
	^sum! !

!HW3Exercises methodsFor: 'exercises' stamp: 'MichaelOSullivan 6/8/2012 11:48'!
reverseArrayTheEasyWay: anArray
	"This method should answer the elements of anArray in reverse order.
	Make this method in the most easy and trivial way possible.
	Note: It should only be 1 line of code!!"
	
	^anArray reverse
! !

!HW3Exercises methodsFor: 'exercises' stamp: 'MichaelOSullivan 6/8/2012 12:14'!
reverseArrayTheHardWay: anArray
	"This method should answer the elements of anArray in reverse order.
	Implement this method using a control structure of your choice,"
	
	| backwardsArray index inc |
	index := 0.
	inc := [index := index + 1].
	backwardsArray := Array new: anArray size.
	
	anArray reverseDo:	 [:each | 
		inc value.
		backwardsArray at: index put: each
	].
	^backwardsArray
! !

!HW3Exercises methodsFor: 'exercises' stamp: 'MichaelOSullivan 6/8/2012 15:05'!
sumUsingWhileFalse
	"Rewrite this method to use whileFalse: control structure, 
	so that it adds to 'sum' until it reaches the minimum value higher than 100. 
	This method should answer this sum."
	| incrementBlock sumBlock sum index |
	sum := index := 0.
	incrementBlock := [index := index + 1].
	sumBlock := 
		[incrementBlock value.
		sum + (index * index)].
	[sum > 100] whileFalse: [sum := sumBlock value].
	^sum
! !

!HW3Exercises methodsFor: 'exercises' stamp: 'MichaelOSullivan 6/8/2012 15:05'!
sumUsingWhileTrue
	"Rewrite this method to use whileTrue: control structure, 
	so that it adds to 'sum' until it reaches the minimum value higher than 100. 
	This method should answer this sum."
	| incrementBlock sumBlock sum index |
	sum := index := 0.
	incrementBlock := [index := index + 1].
	sumBlock := 
		[incrementBlock value.
		sum + (index * index)].
	[sum <= 100] whileTrue: [sum := sumBlock value].
	^sum
! !

!HW3Exercises methodsFor: 'exercises' stamp: 'MichaelOSullivan 6/8/2012 11:58'!
valueOfEmptyBlock
	"This method should answer the VALUE of an empty block."
	
	^ [ ] value
! !
